/* 
 This file was generated by Dashcode.  
 You may edit this file to customize your widget or web page 
 according to the license.txt file included in the project.
 */

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    dashcode.setupParts();
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
    statusSignal.object.setValue(0);
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}


function calculateCredits(totalCreditsValue)
{
    var fromCreditsArray, toCreditsArray, floatValue;
    fromCreditsArray= new Array(6);
    toCreditsArray=new Array(6);
    floatValue = parseFloat(totalCreditsValue.replace(",", "."));
    fromCreditsArray[1]=roundToHalf(floatValue);
    toCreditsArray[1]=roundToHalf(floatValue*0.92);    
    fromCreditsArray[2]=roundToHalf(floatValue*0.92 - 0.5);
    toCreditsArray[2]=roundToHalf(floatValue*0.81);        
    fromCreditsArray[3]=roundToHalf(floatValue*0.81 - 0.5);    
    toCreditsArray[3]=roundToHalf(floatValue*0.67);        
    fromCreditsArray[4]=roundToHalf(floatValue*0.67 - 0.5);
    toCreditsArray[4]=roundToHalf(floatValue*0.50);        
    fromCreditsArray[5]=roundToHalf(floatValue*0.50 - 0.5);
    toCreditsArray[5]=roundToHalf(floatValue*0.30);        
    fromCreditsArray[6]=roundToHalf(floatValue*0.30 - 0.5);
    toCreditsArray[6]=0;
        
    von1.value=fromCreditsArray[1].toString();
    von2.value=fromCreditsArray[2].toString();
    von3.value=fromCreditsArray[3].toString();    
    von4.value=fromCreditsArray[4].toString();
    von5.value=fromCreditsArray[5].toString();
    von6.value=fromCreditsArray[6].toString();
    von6.value=fromCreditsArray[6].toString();
    bis1.value=toCreditsArray[1].toString();
    bis2.value=toCreditsArray[2].toString();
    bis3.value=toCreditsArray[3].toString();
    bis4.value=toCreditsArray[4].toString();
    bis5.value=toCreditsArray[5].toString();
    bis6.value=toCreditsArray[6].toString();                    
}


function totalCreditsChanged(event)
{
    var totalCreditsValue;

    totalCreditsValue=totalCredits.value;
    if(totalCreditsValue.length==0) {
        statusSignal.object.setValue(0);
        return false;
    }
    if(!allnumeric(totalCreditsValue)) {
        statusSignal.object.setValue(3);
	    von1.value="- E -";
	    von2.value="- E -";
	    von3.value="- E -";    
	    von4.value="- E -";
	    von5.value="- E -";
	    von6.value="- E -";
	    von6.value="- E -";
	    bis1.value="- E -";
	    bis2.value="- E -";
	    bis3.value="- E -";
	    bis4.value="- E -";
	    bis5.value="- E -";
	    bis6.value="- E -";
        return false;
    } else {
        statusSignal.object.setValue(1);
        calculateCredits(totalCreditsValue);
        return true;
    }    
}

function allnumeric(inputtxt)  
{
  inputtxt = inputtxt.replace(",", ".")
  return !isNaN(parseFloat(inputtxt)) && isFinite(inputtxt); 
}

function roundToHalf(value) { 
    var converted, decimal;
    converted = parseFloat(value);
    decimal = (converted - parseInt(converted, 10)); 
    decimal = Math.round(decimal * 10); 
    if (decimal == 5) { return (parseInt(converted, 10)+0.5); } 
    if ( (decimal < 3) || (decimal > 7) ) { 
        return Math.round(converted); 
    } else {
        return (parseInt(converted, 10)+0.5); 
    } 
} 